#!/bin/bash

DEBUGG=0
BFPath=$1
File=$2
UAccount=$3

FBasePath=`echo "$File" | awk '{match($1, "^.*/"); print substr($1, 1, RLENGTH-1)}'`

fffile=`/bin/basename $File`

UserDom=`echo $UAccount | awk -F@ '{print $2}'`
UserName=`echo $UAccount | sed 's/@.*//g'`

RDB="/var/MailRoot/.SpamDB/wordlist.db"
UBasePath="/var/MailRoot/domains/$UserDom/$UserName"

out_file="$UBasePath/Maildir/new/$fffile"
tmp_file="$UBasePath/Maildir/tmp/$fffile.spam"

BasePath=$UBasePath

SpamStorageFolder="$UBasePath/Maildir/.Spam"
DBpath="$UBasePath/.SpamDB"

timestamp=`echo "$File" | awk -F/ '{print $NF}'`
date=`date +%Y%m%d000`
nowtime=`date +%T`
File_size=`du -b $File | awk '{print $1}'`

Exit="7"

if [ -d $DBpath ]; then 
	if [$DEBUGG = "1" ] 
    echo "$date	$nowtime	$UAccount	$fffile	\".SpamDB folder exists, going to check WORDLIST.DB...\""  >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi
else
	if [$DEBUGG = "1" ] 
    echo "$date	$nowtime	$UAccount	$fffile	\".SpamDB unexists, creating folder to keep WORDLIST.DB...\"" >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi
    mkdir -p $DBpath
fi

UDB="$DBpath/wordlist.db"

if [ -s $UDB ]; then 
	if [$DEBUGG = "1" ] 
    echo "$date	$nowtime	$UAccount	$fffile	\"WORDLIST.DB file is exist and is not ZERO SIZE, going to check mail...\""  >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi
else
	if [$DEBUGG = "1" ] 
    echo "$date	$nowtime	$UAccount	$fffile	\"WORDLIST.DB file is absent or ZERO SIZE, NEED TO LEARN SPAMFILTER before usage, exiting...\""  >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi
    if [ -s $RDB ]; then 
	cp $RDB $UDB
    fi
#    exit $Exit
fi


if [ -f $File ]; then 
	if [$DEBUGG = "1" ] 
    echo "$date	$nowtime	$UAccount	$fffile	\"MSG:'$File' exists, going to detect spam level...\""  >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi

#mv $File $tm_file
sed '1,/^<<MAIL-DATA>>/{d}' <$File>>$tmp_file && rm -rf $File
$BFPath -p --spam-header-name="X-Spam-Header" -I "$tmp_file" -O "$out_file" -d "$DBpath"

rm -rf $tmp_file


#LOG MSG
echo "$date	$nowtime	Inspected:\"$File\"	Size:$File_size	Account:\"$UAccount\"	Database:\"$DBpath\"" >> /var/MailRoot/logs/spamfilter-detect-$date

    Exit="3"

else
	if [$DEBUGG = "1" ] 
    echo "$date	$nowtime	$UAccount	$fffile	\"MSG:'$File' unexists, going to exit...\""  >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi
    Exit="7"
fi

	if [$DEBUGG = "1" ] 
echo "$date	$nowtime	$UAccount	$fffile	\"Spamfilter ends analise...\""  >> /var/MailRoot/logs/spamfilter-detect-DEBUG-$date
	fi

exit $Exit
