<?php

/*
 * AfterLogic Admin Panel by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 * 
 */

	class CXMailUser
	{
		/**
		 * @var string
		 */
		var $_email;
		
		/**
		 * @var string
		 */
		var $_login;
		
		/**
		 * @var	string
		 */
		var $_password;
		
		/**
		 * @var	int (bytes)
		 */
		var $_mailBoxSize = 0;

		/**
		 * @var	array
		 */
		var $_mlusers = array();
		
		/**
		 * @var	array
		 */
		var $_alias = array();
		
		/**
		 * @var	array
		 */
		var $_act_forwards = array();
		
		/**
		 * @var	bool
		 */
		var $_storeMailInMailbox;
		
		function SetSessionArray()
		{
			$array = array(
'_mailBoxSize' => $this->_mailBoxSize,
'_mlusers' => $this->_mlusers,
'_alias' => $this->_alias,
'_act_forwards' => $this->_act_forwards,
'_storeMailInMailbox' => $this->_storeMailInMailbox
				);
					
			$_SESSION[XM_SESS_USER] = $array;
		}
		
		function ClearSessionArray()
		{
			if (isset($_SESSION[XM_SESS_USER]))
			{
				unset($_SESSION[XM_SESS_USER]);
			}
		}		

		function UpdateFromSessionArray()
		{
			$sessionArray = isset($_SESSION[XM_SESS_USER]) ? $_SESSION[XM_SESS_USER] : array();
			if (count($sessionArray) > 0)
			{
				$this->_mailBoxSize = (int) ap_Utils::ArrayValue($sessionArray, '_mailBoxSize', $this->_mailBoxSize);
				$this->_mlusers = ap_Utils::ArrayValue($sessionArray, '_mlusers', $this->_mlusers);
				$this->_alias = ap_Utils::ArrayValue($sessionArray, '_alias', $this->_alias);
				$this->_act_forwards = ap_Utils::ArrayValue($sessionArray, '_act_forwards', $this->_act_forwards);
				$this->_storeMailInMailbox = (bool) ap_Utils::ArrayValue($sessionArray, '_storeMailInMailbox', $this->_storeMailInMailbox);
				
				$this->ClearSessionArray();
			}
		}
		
		/**
		 * @return bool
		 */
		function IsSessionData()
		{
			return isset($_SESSION[XM_SESS_USER]);
		}
		
		/**
		 * @param	array	$vars
		 */
		function UpdateFromUserVars($vars)
		{
			if (is_array($vars) && count($vars) > 0)
			{
				$mailBoxSize = isset($vars['MaxMBSize']) ? (int) round($vars['MaxMBSize'] * 1024) : null; 
				$this->_mailBoxSize = ($mailBoxSize === null) ? $this->_mailBoxSize : $mailBoxSize;
				$this->_storeMailInMailbox = (isset($vars['StoreMailLocaly']) && $vars['StoreMailLocaly'] == 1);
			}
		}

		/**
		 * @param	array	$ret
		 */
		function UpdateFromGetMailProc($ret)
		{
			if (is_array($ret) && count($ret) > 0)
			{
				foreach ($ret as $line)
				{
					$arr = explode(AP_TAB, $line);
					if (count($arr) > 0 && $arr[0] == '"lredirect"')
					{
						for ($i = 1, $c = count($arr); $i < $c; $i++)
						{
							$this->_act_forwards[] = trim($arr[$i], '"');
						}
					}
				}
			}
		}
		
		/**
		 * @param	array	$aliases
		 */
		function UpdateFromAliasList($aliases)
		{
			if (is_array($aliases) && count($aliases) > 0)
			{
				foreach ($aliases as $item)
				{
					if (is_array($item) && count($item) == 3)
					{
						$this->_alias[] = $item[1];
					}
				}
			}
		}
		
		/**
		 * @param	array	$mlusers
		 */
		function UpdateFromMlUserList($mlusers)
		{
			if (is_array($mlusers) && count($mlusers) > 0)
			{
				foreach ($mlusers as $user)
				{
					if (count($user) == 2)
					{
						$this->_mlusers[] = $user;
					}
				}
			}
		}
		
		/**
		 * @return array
		 */
		function ToRedirectDataArray()
		{
			$return = array();
			
			if (count($this->_act_forwards) > 0)
			{
				$text = '"lredirect"';
				foreach ($this->_act_forwards as $item)
				{
					$text .= AP_TAB.'"'.$item.'"';
				}
				$return[] = $text;
			}
			
			return $return;
		}
		
		/**
		 * @return array
		 */
		function GetAliasArray()
		{
			return $this->_alias;
		}
	}