<?php

/*
 * AfterLogic WebMail Pro PHP by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the proprietary AfterLogic Computer License (LICENSE.txt)
 * 
 */

	header('Content-Type: text/html; charset=utf-8');
	
	@session_name('PHPWEBMAILSESSID');
	@session_start();

	function fixed_array_map_stripslashes($array)
	{
		if (is_array($array))
		{
			foreach ($array as $key => $value)
			{
				$array[$key] = (is_array($value))
						? @fixed_array_map_stripslashes($value)
						: @stripslashes($value);
			}
		}
		return $array;
	}
	
	function disable_magic_quotes_gpc()
	{
		if (@get_magic_quotes_gpc() == 1)
		{
			$_GET = fixed_array_map_stripslashes($_GET);
			$_POST = fixed_array_map_stripslashes($_POST);
		}
	}
	
	@disable_magic_quotes_gpc();
	
	if (!defined('WM_ROOTPATH')) define('WM_ROOTPATH', (dirname(__FILE__).'/'));

	require_once(WM_ROOTPATH.'common/inc_constants.php');
	require_once(WM_ROOTPATH.'class_settings.php');
	
	$settings =& Settings::CreateInstance();
	
	if (!$settings || !$settings->isLoad)
	{
		exit('<script>parent.changeLocation("'.LOGINFILE.'?error=3");</script>');
	} 
	else if (!$settings->IncludeLang())
	{
		exit('<script>parent.changeLocation("'.LOGINFILE.'?error=6");</script>');
	}
	
	require_once(WM_ROOTPATH.'class_account.php');
	require_once(WM_ROOTPATH.'classic/base_defines.php');
	require_once(WM_ROOTPATH.'common/class_log.php');
	
	require_once(WM_ROOTPATH.'classic/class_getmessagebase.php');
	
	$log =& CLog::CreateInstance();
	
	if (!Session::has(ACCOUNT_ID))
	{
		exit('<script>parent.changeLocation("'.LOGINFILE.'?error=1");</script>');
	}	
	
	$_SESSION['attachtempdir'] = Session::val('attachtempdir', md5(session_id()));
	$account =& Account::LoadFromDb(Session::val(ACCOUNT_ID, -1));
	if (!$account)
	{
		exit('<script>parent.changeLocation("'.LOGINFILE.'?error=2");</script>');
	}
	
	$_rtl = ($account->DefaultLanguage == 'Hebrew');
	$_style = ($_rtl) ? '<link rel="stylesheet" href="skins/'.$account->DefaultSkin.'/styles-rtl.css" type="text/css" id="skin-rtl">' : '';
	
	$msg = null;
	$isNull = false;

	$_tname = Get::val('tn', '');

	if ($_tname)
	{
		$_fs = new FileSystem(INI_DIR.'/temp', $account->Email, $account->Id);
		$_attfolder = new Folder($account->Id, -1, $_SESSION['attachtempdir']);
		
		$GLOBALS[MailDefaultCharset] = $account->GetDefaultIncCharset();
		$GLOBALS[MailOutputCharset] = $account->GetUserCharset();
		
		$msg =& $_fs->LoadMessageFromTemp($_tname, $_attfolder);
	}
	else 
	{
		$isNull = true;
	}
	
	if ($isNull || null === $msg)
	{
		exit(PROC_MSG_HAS_DELETED);
	}
	
	$CCTr = $AttachTr = '';
	$ccString = $msg->GetCcAsString(true);
	if (strlen($ccString) > 0)
	{
		$CCTr = '
	<tr>
		<td class="wm_print_title" width="60px">
			'.JS_LANG_CC.' 
		</td>
		<td class="wm_print_value">
			'.ConvertUtils::WMHtmlSpecialChars($ccString).'
		</td>
	</tr>';
	}
	
	if ($msg->Attachments && $_attfolder && $msg->Attachments->Count() > 0)
	{
		$attachStr = '';
		$attachmentsKeys = array_keys($msg->Attachments->Instance());
		foreach ($attachmentsKeys as $key)
		{
			$attachment =& $msg->Attachments->Get($key);
			$tempname = $key.'_'.ConvertUtils::ClearFileName($attachment->GetTempName());
			$filename = ConvertUtils::ClearFileName(ConvertUtils::ClearUtf8($attachment->GetFilenameFromMime(), $GLOBALS[MailInputCharset], $account->GetUserCharset()));
			
			$view = $download = null;
			$size = $_fs->SaveAttach($attachment, $_attfolder, $tempname);
			if ($size > -1)
			{
				$download = 'attach.php?tn='.urlencode($tempname).'&filename='.urlencode($filename);
			
				$_tfilename = strtolower($filename);
				$_contentType = ConvertUtils::GetContentTypeFromFileName($filename);
				if ($_tfilename == 'winmail.dat' || substr($_tfilename, -4) == '.eml')
				{
					$view = 'view-msg.php?tn='.urlencode($tempname);
				}
				else if (false !== strpos($_contentType, 'image'))
				{
					$view = 'view-image.php?tn='.urlencode($tempname);
				}
			}
			
			$attachStr .= ' <a href="'.ConvertUtils::AttributeQuote($download).'">'.$filename.'</a>';
			$attachStr .= (null !== $view) ? ' (<a href="'.ConvertUtils::AttributeQuote($view).'">'.JS_LANG_View.'</a>)' : '';
			$attachStr .= ',';
			
			unset($attachment);
		}

		if (strlen($attachStr) > 0)
		{
			$AttachTr = '
<tr>
	<td class="wm_print_title" width="60px">
		'.Attachments.':
	</td>
	<td class="wm_print_value">
		'.trim($attachStr, ',').'
	</td>
</tr>';
		}
	}
	
	$date =& $msg->GetDate();
	$date->FormatString = $account->DefaultDateFormat;
	$date->TimeFormat = $account->DefaultTimeFormat;
	$dateString = $date->GetFormattedDate($account->GetDefaultTimeOffset());
	
	function PrintHtmlBody(&$msg, $account, $isEncode = true)
	{
		$newtext = '';
		if (($account->ViewMode == VIEW_MODE_PREVIEW_PANE_NO_IMG || $account->ViewMode == VIEW_MODE_WITHOUT_PREVIEW_PANE_NO_IMG))
		{
			$newtext = ConvertUtils::HtmlBodyWithoutImages($msg->GetCensoredHtmlWithImageLinks($isEncode));
			if (isset($GLOBALS[GL_WITHIMG]) && $GLOBALS[GL_WITHIMG])
			{
				$GLOBALS[GL_WITHIMG] = false;
			}
		}
		else 
		{
			$newtext = $msg->GetCensoredHtmlWithImageLinks($isEncode);
		}

		return $newtext;
	}
	
	$_styleText = ' style="text-align: left;"';
	$_textCharset = ($msg) ? $msg->GetTextCharset() : null;
	if (null !== $_textCharset)
	{
		if (strtolower($_textCharset) == 'iso-8859-8-i')
		{
			$_styleText = ' style="text-align: right;"';
		}
		else 
		{
			switch (ConvertUtils::GetCodePageNumber($_textCharset))
			{
				case 1255:
				case 1256:
				case 28596:
				case 28598:
					$_styleText = ' style="text-align: right;"';
					break;
				case 65001:
					if ($_rtl)
					{
						$_styleText = ' style="text-align: right;"';	
					}
					break;
			}
		}
	}
	
	$fullBodyText = ($msg->HasHtmlText()) 
		? ConvertUtils::ReplaceJSMethod(PrintHtmlBody($msg, $account, true))
		: nl2br($msg->GetCensoredTextBody(true));

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" />
<html>
	<head>
		<link rel="stylesheet" href="./skins/<?php echo $account->DefaultSkin;?>/styles.css" type="text/css" />
		<?php echo $_style; ?>
	</head>
	<body class="wm_body">
		<div align="center" class="wm_space_before">
			<table class="wm_print">
				<tr>
					<td class="wm_print_title" width="60px">
					<?php echo JS_LANG_From;?>: 
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($msg->GetFromAsString(true)); ?>
					</td>
				</tr>
				<tr>
					<td class="wm_print_title" width="60px">
						<?php echo JS_LANG_To;?>: 
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($msg->GetToAsString(true)); ?>
					</td>
				</tr>
				<?php echo $CCTr; ?>
				<tr>
					<td class="wm_print_title" width="60px">
						<?php echo JS_LANG_Date;?>:
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($dateString);	?>
					</td>
				</tr>
				<tr>
					<td class="wm_print_title" width="60px">
						<?php echo JS_LANG_Subject;?>:
					</td>
					<td class="wm_print_value">
						<?php echo ConvertUtils::WMHtmlSpecialChars($msg->GetSubject(true)); ?>
					</td>
				</tr>
				<?php echo $AttachTr; ?>
				<tr>
					<td colspan="2" class="wm_print_body">
						<div class="wm_space_before"<?php echo $_styleText; ?>>
							<?php echo $fullBodyText; ?>
						</div>
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>